﻿using Infragistics.Windows.DataPresenter;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;

namespace PopulatingFieldsDynamically
{
    /// <summary>
    /// Interaction logic for MainWindow.xaml
    /// </summary>
    public partial class MainWindow : Window
    {
        MainWindowViewModel ViewModel;
        public MainWindow()
        {
            InitializeComponent();
            ViewModel = new MainWindowViewModel();
            this.DataContext = ViewModel;
        }

        private void Button_Click(object sender, RoutedEventArgs e)
        {
            ((MainWindowViewModel)this.DataContext).GenerateData();

            var staffMember = this.ViewModel.StaffMembers.First();

            for (Int32 i = 0; i < staffMember.Staff.Count; i++)
            {
                var field = new UnboundField
                {
                    Name = staffMember.Staff[i].Name,
                    BindingMode = BindingMode.TwoWay,
                    BindingPath = new PropertyPath(String.Format("Staff[{0}].Value", i))
                };

                field.Settings.EditAsType = typeof(String);
                xdg.FieldLayouts[0].Fields.Add(field);
            }

        }
    }
}
