﻿using System;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.ComponentModel;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace PopulatingFieldsDynamically
{
    public class MainWindowViewModel : INotifyPropertyChanged
    {
        #region INotifyPropertyChanged Implementation
        public event PropertyChangedEventHandler PropertyChanged;
        protected void OnPropertyChanged(string propertyName)
        {
            if (PropertyChanged != null)
                PropertyChanged(this, new PropertyChangedEventArgs(propertyName));
        }
        #endregion

        private ObservableCollection<StaffMember> _staffMembers;
        public ObservableCollection<StaffMember> StaffMembers
        {
            get { return _staffMembers; }
            set
            {
                if (_staffMembers != value)
                {
                    _staffMembers = value;
                    OnPropertyChanged("StaffMembers");
                }
            }
        }

        public MainWindowViewModel()
        {
            //Moved your code to method as it will generated during runtime
        }

        public void GenerateData()
        {
            StaffMembers = new ObservableCollection<StaffMember>();
            StaffMembers.Add(new StaffMember { StaffCategory = "category1", StaffTypes = "type1", Staff = new List<Staff>() });
            StaffMembers[0].Staff.Add(new Staff { Name = "staff1", Value = "value1" });
            StaffMembers[0].Staff.Add(new Staff { Name = "staff2", Value = "value1" });
            StaffMembers[0].Staff.Add(new Staff { Name = "staff3", Value = "value1" });
            StaffMembers[0].Staff.Add(new Staff { Name = "staff4", Value = "value1" });

            StaffMembers.Add(new StaffMember { StaffCategory = "category2", StaffTypes = "type2", Staff = new List<Staff>() });
            StaffMembers[1].Staff.Add(new Staff { Name = "staff1", Value = "value2" });
            StaffMembers[1].Staff.Add(new Staff { Name = "staff2", Value = "value2" });
            StaffMembers[1].Staff.Add(new Staff { Name = "staff3", Value = "value2" });
            StaffMembers[1].Staff.Add(new Staff { Name = "staff4", Value = "value2" });

            StaffMembers.Add(new StaffMember { StaffCategory = "category3", StaffTypes = "type3", Staff = new List<Staff>() });
            StaffMembers[2].Staff.Add(new Staff { Name = "staff1", Value = "value3" });
            StaffMembers[2].Staff.Add(new Staff { Name = "staff2", Value = "value3" });
            StaffMembers[2].Staff.Add(new Staff { Name = "staff3", Value = "value3" });
            StaffMembers[2].Staff.Add(new Staff { Name = "staff4", Value = "value3" });
        }
    }

    public class StaffMember
    {
        public string StaffCategory { get; set; }
        public string StaffTypes { get; set; }
        public List<Staff> Staff { get; set; }
    }

    public class Staff
    {
        public string Name { get; set; }
        public string Value { get; set; }
    }
}
